#{extends 'border.html'/}
<div class="container">
#{form @admin.ProdukKategoriAtributCtr.createSubmit(), method:'POST', class:'form-horizontal', id:'attribute-form'}
    <input id="attribute-placeholder" class="form-control" name="model.specifications" value="${model?.specifications}" type="hidden">
    <input class="form-control" name="model.pkid" value="${model?.pkid}" type="hidden">
    <input class="form-control" name="model.kid" value="${model?.kid}" type="hidden">

    <div class="row">
		<div class="col-md-12">
			<!-- Breadcrumb -->
			<ol class="breadcrumb">
				<li><a href="@{PublikCtr.home()}">&{'beranda.label'}</a></li>
				<li><a href="@{admin.KomoditasCtr.index()}">&{'komoditas.label'}</a></li>
				<li><a href="@{admin.ProdukKategoriCtr.index(model?.kid)}">&{'kategori_produk.label'}</a></li>
				<li class="active">&{'tambah.label'} &{'kategori_atribut.label'}</li>
			</ol>
			<!-- End Breadcrumb -->
		</div>
	</div>
	
	<div class="row">
		<div class="col-md-12">
			#{alert /}
			<!-- Toolbar -->
			<div class="toolbar">
				#{backButton action:@admin.ProdukKategoriCtr.index(model?.kid)/}
				#{saveButton/}
			</div>
			<!-- End Toolbar -->
		</div>
	</div>

	<div class="row">
		<div class="col-md-12">
			<div class="panel panel-default">
				<div class="panel-body">
					#{include '/admin/ProdukKategoriAtributCtr/_formInput.html' /}
				</div>
			</div>
		</div>
	</div>

#{/form}
</div>

#{set 'moreScripts'}
<script src="@{'/public/javascripts/jquery.validate.min.js'}" type="text/javascript"> </script>
<script src="@{'/public/javascripts/ladda/spin.min.js'}" type="text/javascript"> </script>
<script src="@{'/public/javascripts/ladda/ladda.min.js'}" type="text/javascript"> </script>
<script src="@{'/public/javascripts/toast/jquery.toast.min.js'}" type="text/javascript"> </script>

<script type="text/javascript">

	var types = ${types != null ? models.jcommon.util.CommonUtil.toJson(types).raw() : []};

    jQuery(document).ready(function($) {

        jQuery('#attribute-form').on('submit', function (e) {
            var results = generateArray();
            jQuery('#attribute-placeholder').val(generateJson(results));
            if(!isValidInput(results)) {
                e.preventDefault(); //prevent the default action
            }
        });

        var temporaryId = 1;
        jQuery("#addInput").on("click",function(){
			var str = '<tr data-value="">' +
			'<td><a class="btn btn-danger remove-input ladda-button trash-' + temporaryId + '" data-value="'+temporaryId+'" data-style="zoom-out"><i class="fa fa-trash"></i></a></td>' +
			'<td><input class="form-control input-attr" name="labelAtribut" type="text" required></td>' +
			'<td><input class="form-control input-attr-desc" name="deskripsi" type="text"/></td>' +
			'<td>' +
			'<select class="form-control dropdown-input-type valid" name="tipeInput">' +
            '<option value="text" selected="selected">Text</option>' +
            '<option value="textarea">Textarea</option>' +
            '<option value="label">Label</option>' +
            '</select>' +
            '</td>' +
			'<td>' +
					generateSelect() +
			'</td>'+
            '<td class="header-center"><input class="input-is-required" value="0" name="wajidDiisi" type="checkbox"></td>' +
			'</tr>';
			temporaryId++;
            jQuery("#inputForm").append(str);
		});
        jQuery(document).on("click", ".remove-input", function(){
			deleteItem(jQuery(this))
		});

		jQuery("#removeAllInput").on("click",function(){
            jQuery("#inputForm tr").remove();
		});

		function deleteElement(view) {
			view.parent().parent().remove();
		}

		function generateSelect() {
			var template = '<select required class="form-control dropdown-information-type valid" name="tipeAtribut">';
			template += '<option value="" selected="selected">Pilih</option>' ;
			for (var i in types) {
			    template += '<option value="' + types[i].id + '">' + types[i].tipe_atribut + '</option>';
			}
			template += '</select>';
			return template;
		}

		function deleteItem(view) {
            var id = view.parent().parent().data('value');
		    var loader = Ladda.create(document.querySelector('.trash-' + view.data('value')));
		    loader.start();
		    // console.log('id: ' + id);
			if (id === '') {
                loader.stop();
                deleteElement(view);
			} else {
			    jQuery.ajax({
					url: "@{admin.ProdukKategoriAtributCtr.delete()}",
					type: 'POST',
					data: {
					    pkid: id
					}
				}).success(function (s) {
                    loader.stop();
				    if (s.status) {
                        deleteElement(view);
                    } else {
				        showToast();
					}
				}).fail(function (e) {
                    // console.log("error: " + JSON.stringify(e));
                    loader.stop();
                    showToast();
				});
			}
		}

		function generateArray() {
            var children = jQuery("#inputForm").children('tr');
            var results = [];
            if (children.length > 0) {
                for (var i = 0; i < children.length; i++) {
                    var view = children.eq(i);
					var data = {};
					data['id'] = view.data('value') !== '' ? view.data('value') : -1;
					data['label'] = view.find('.input-attr').val();
                    data['desc'] = view.find('.input-attr-desc').val();
                    data['isRequired'] = view.find('.input-is-required').is(':checked');
                    data['type'] = view.find('.dropdown-input-type').val();
                    data['informationType'] = view.find('.dropdown-information-type').val();
					results.push(data);
                }
            }
            return results;
		}

		function isValidInput(results) {
			var totalEmpty = 0;
			if (results.length > 0) {
			    for (var i in results) {
			        var data = results[i];
			        if (data.label === '' || data.informationType === 0) {
			            totalEmpty++;
					}
				}
			}
			return totalEmpty === 0;
		}

		function generateJson(results) {
            var stringResult = JSON.stringify(results);
            return stringResult;
		}

		function showToast() {
            $.toast({
                heading: 'Oops',
                text: 'Data tidak bisa dihapus, terdapat relasi!',
                position: 'bottom-center',
                stack: false,
				icon: 'error',
                hideAfter: 6000
            })
		}

    });
</script>
#{/set}